/******************** (C) COPYRIGHT 2013 MJX ***********************************
* File Name          : SPI_FLAH.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/08/01
* Description        : SPI FLASHоƬļ
*******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "ch32v30x_usbhs_device.h"
#include "ch32v30x_spi.h"
#include "SW_UDISK.H"
#include "SPI_FLASH.H"

/******************************************************************************/
/*  */
UINT8V  Flash_Type = 0x00;											           /* FLASHоƬ: 0: W25XXXϵ; 1: SST25XXXϵ; 2: MT25QXXϵ  */
UINT32V Flash_ID = 0x00;											           /* FLASHоƬID */
UINT32V Flash_Sector_Count = 0x00;									           /* FLASHоƬ */
UINT16V Flash_Sector_Size = 0x00;									           /* FLASHоƬС */

UINT32V Flash_Erase_Address = 0xFFFFFFFF;							           /* FLASHʼַ */
UINT8   Flash_BackUp_Buf[ DEF_FLASH_BUF_LEN ];					               /* FLASHݻ */

UINT8V  Flash_Cur_Hold_SecNum = 0x00;                                           /* FLASHǰʹõı */
UINT8V  Flash_Erase_Flag = 0x00;                                                /* FLASH־ */
UINT8V  Flash_Used_Flag = 0x00;                                                 /* FLASH־(ÿλʾһ512ֽڵС) */

/*******************************************************************************
* Function Name  : FLASH_Port_Init
* Description    : FLASHоƬźӲʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void FLASH_Port_Init( void )
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};
    SPI_InitTypeDef  SPI_InitStructure = {0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOE, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI3, ENABLE);

    /*CS#*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOE, &GPIO_InitStructure);
    GPIO_SetBits(GPIOE, GPIO_Pin_6);

    /*SCK*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    /*MISO*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    /*MOSI*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI3, &SPI_InitStructure);

    SPI_Cmd(SPI3, ENABLE);
}

/*********************************************************************
 * @fn      SPI3_ReadWriteByte
 *
 * @brief   SPI3 read or write one byte.
 *
 * @param   TxData - write one byte data.
 *
 * @return  Read one byte data.
 */
UINT8 SPI3_ReadWriteByte(UINT8 TxData)
{
    UINT8 i = 0;

    while(SPI_I2S_GetFlagStatus(SPI3, SPI_I2S_FLAG_TXE) == RESET)
    {
        i++;
        if(i > 200)
            return 0;
    }

    SPI_I2S_SendData(SPI3, TxData);
    i = 0;

    while(SPI_I2S_GetFlagStatus(SPI3, SPI_I2S_FLAG_RXNE) == RESET)
    {
        i++;
        if(i > 200)
            return 0;
    }

    return SPI_I2S_ReceiveData(SPI3);
}

/*******************************************************************************
* Function Name  : SPI_FLASH_SendByte
* Description    : SPIһֽ
* Input          : byte: Ҫ͵ֽ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 SPI_FLASH_SendByte( UINT8 byte )
{
    return SPI3_ReadWriteByte( byte );
}

/*******************************************************************************
* Function Name  : SPI_FLASH_ReadByte
* Description    : SPIһֽ
* Input          : None
* Output         : None
* Return         : ؽյֽ
*******************************************************************************/
UINT8 SPI_FLASH_ReadByte( void )
{
    return SPI3_ReadWriteByte( 0xFF );
}

/*******************************************************************************
* Function Name  : FLASH_ReadID
* Description    : ȡFLASHоƬID
* Input          : None
* Output         : None
* Return         : 4ֽ,ֽΪ0x00,
*                  θֽΪManufacturer ID(0xEF),
*                  εֽΪMemory Type ID
*                  ֽΪCapacity ID
*                  W25X40BL: 0xEF0x300x13
*                  W25X10BL: 0xEF0x300x11
*******************************************************************************/
UINT32 FLASH_ReadID( void )
{
	UINT32 dat;

	/* Select the FLASH: Chip Select low */
	PIN_FLASH_CS_LOW( );

	/* Send "RDID " instruction */
	SPI_FLASH_SendByte( CMD_FLASH_JEDEC_ID );									/* ͶȡJEDEC_ID */

	/* Read a byte from the FLASH */
	dat = ( UINT32 )SPI_FLASH_SendByte( DEF_DUMMY_BYTE ) << 16;

	/* Read a byte from the FLASH */
	dat |= ( UINT32 )SPI_FLASH_SendByte( DEF_DUMMY_BYTE ) << 8;

	/* Read a byte from the FLASH */
	dat |= SPI_FLASH_SendByte( DEF_DUMMY_BYTE );

	/* Deselect the FLASH: Chip Select high */
	PIN_FLASH_CS_HIGH( );
	return( dat );
}

/*******************************************************************************
* Function Name  : FLASH_WriteEnable
* Description    : FLASHоƬд
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void FLASH_WriteEnable( void )
{
    PIN_FLASH_CS_LOW( );
	SPI_FLASH_SendByte( CMD_FLASH_WREN );		   		  			 			/* д */					
	PIN_FLASH_CS_HIGH( );
}

/*******************************************************************************
* Function Name  : FLASH_WriteDisable
* Description    : FLASHоƬֹд
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void FLASH_WriteDisable( void )
{
    PIN_FLASH_CS_LOW( );
	SPI_FLASH_SendByte( CMD_FLASH_WRDI );		   		  			 			/* ͽֹд */					
	PIN_FLASH_CS_HIGH( );
}

/*******************************************************************************
* Function Name  : FLASH_ReadStatusReg
* Description    : FLASHоƬȡ״̬Ĵ 
* Input          : None
* Output         : None
* Return         : ؼĴֵ
*******************************************************************************/
UINT8 FLASH_ReadStatusReg( void )
{
	UINT8  status;

	PIN_FLASH_CS_LOW( );
	SPI_FLASH_SendByte( CMD_FLASH_RDSR );		   		  			 			/* Ͷȡ״̬Ĵ*/					
	status = SPI_FLASH_ReadByte( );
	PIN_FLASH_CS_HIGH( );
	return( status );
}

/*******************************************************************************
* Function Name  : FLASH_WriteStatusReg
* Description    : FLASHоƬд״̬Ĵ
* Input          : statusdata---Ҫд״̬Ĵֵ
* Output         : None
* Return         : None
* ע:д״̬Ĵǰ,ȷEnable-Write-Status-Register (EWSR),0X50Write-Enable,0X06
*******************************************************************************/
void FLASH_WriteStatusReg( UINT8 dat )
{
    PIN_FLASH_CS_LOW( );
 	SPI_FLASH_SendByte( CMD_FLASH_EWSR );		   		  			 			/* д״̬Ĵ */					
 	PIN_FLASH_CS_HIGH( );
	
	PIN_FLASH_CS_LOW( );
 	SPI_FLASH_SendByte( CMD_FLASH_WRSR );		   		  			 			/* д״̬Ĵ */				
 	SPI_FLASH_SendByte( dat );		   		  				 					/* ״̬Ĵֵ */
 	PIN_FLASH_CS_HIGH( );
}

/*******************************************************************************
* Function Name  : FLASH_Erase_Sector
* Description    : FLASHݲ
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/ 
void FLASH_Erase_Sector( UINT32 address )
{
	UINT8  temp;

	/* ֮ǰ,дʹܲ */
	FLASH_WriteEnable( );									 					/* дʹ */

	/* жMT25QXXXоƬҪжϵַֽ,ǰĸ  */
	if( Flash_Type == DEF_TYPE_MT25QXXX )
	{
		MT25QXXX_ChangeExAddrReg( (UINT8)( address >> 24 ) );
	}

	/* FLASH */
	PIN_FLASH_CS_LOW( );
	if( Flash_Type == DEF_TYPE_M25PXXX )
	{
	    SPI_FLASH_SendByte( CMD_M25PXX_SECTOR_ERASE );
	}
	else
	{
	    SPI_FLASH_SendByte( CMD_FLASH_SECTOR_ERASE );                           /* 4-KByte Sector-Erase */
    }
	SPI_FLASH_SendByte( (UINT8)( address >> 16 ) );		     					/* ֽҪȡݵĵַ */					
	SPI_FLASH_SendByte( (UINT8)( address >> 8 ) );		     					/* ݵַֽ */					
	SPI_FLASH_SendByte( (UINT8)address );		   		  	 					/* ݵַֽ */ 
	PIN_FLASH_CS_HIGH( );

	/* ȴ */
	do
	{
		temp = FLASH_ReadStatusReg( );	
	}while( temp & 0x01 );										     			/* ȴǰִ */  	
}

/*******************************************************************************
* Function Name  : FLASH_RD_Block_Start
* Description    : FLASHݶȡʼ
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/  
void FLASH_RD_Block_Start( UINT32 address )
{
	/* W25ϵFLASHSSTϵFLASH */
    PIN_FLASH_CS_LOW( );
	SPI_FLASH_SendByte( CMD_FLASH_READ );
	SPI_FLASH_SendByte( (UINT8)( address >> 16 ) );
	SPI_FLASH_SendByte( (UINT8)( address >> 8 ) );
	SPI_FLASH_SendByte( (UINT8)address );
}

/*******************************************************************************
* Function Name  : FLASH_RD_Block
* Description    : FLASHݶȡ
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/  
void FLASH_RD_Block( UINT8 *pbuf, UINT32 len )
{
	/* W25ϵFLASHSSTϵFLASH */
	while( len-- ) 															
	{
		*pbuf++ = SPI_FLASH_ReadByte( );
	}
}

/*******************************************************************************
* Function Name  : FLASH_RD_Block_End
* Description    : FLASHݶȡ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void FLASH_RD_Block_End( void )
{
    PIN_FLASH_CS_HIGH( );
}

/*******************************************************************************
* Function Name  : W25XXX_WR_Page
* Description    : дһ
*				   עǰֿ֧ҳд	  
* Input          : address----׼д׵ַ
*				   len--------׼дݳ
*				   *pbuf------׼дĻַ 
* Output         : None
* Return         : None
*******************************************************************************/
void W25XXX_WR_Page( UINT8 *pbuf, UINT32 address, UINT32 len )
{
	UINT8  temp;

	/* д֮ǰȴдʹ,ұдڲĵַ */
	FLASH_WriteEnable( );														/* дʹ */

	/* жMT25QXXXоƬҪжϵַֽ,ǰĸ  */
	if( Flash_Type == DEF_TYPE_MT25QXXX )
	{
		MT25QXXX_ChangeExAddrReg( (UINT8)( address >> 24 ) );
	}

	/* ʼд */
	/* Select the FLASH: Chip Select low */
	PIN_FLASH_CS_LOW( );

	/* Send "Write to Memory " instruction */
	SPI_FLASH_SendByte( CMD_FLASH_BYTE_PROG );									/* Ͷȡ */

	/* Send address high nibble address byte to write to */
	SPI_FLASH_SendByte( (UINT8)( address >> 16 ) );

	/* Send address medium nibble address byte to write to */
	SPI_FLASH_SendByte( (UINT8)( address >> 8 ) );

	/* Send address low nibble address byte to write to */
	SPI_FLASH_SendByte( (UINT8)address );

	if( len > SPI_FLASH_PerWritePageSize )										/* ޶ */
	{
		len = SPI_FLASH_PerWritePageSize;
	}

	/* while there is data to be written on the FLASH */
	while( len-- )
	{
		/* Send the current byte */
		SPI_FLASH_SendByte( *pbuf++ );
	}

	/* Deselect the FLASH: Chip Select high */
	PIN_FLASH_CS_HIGH( );

	/* Wait the end of Flash writing */
	do
	{
		temp = FLASH_ReadStatusReg( );	
	}while( temp & 0x01 );										     			/* ȴǰִ */  
}

/*******************************************************************************
* Function Name  : W25XXX_WR_Block
* Description    : дһ
* Input          : address----׼д׵ַ
*				   len--------׼дݳ
*				   *pbuf------׼дĻַ
* Output         : None
* Return         : None
*******************************************************************************/
void W25XXX_WR_Block( UINT8 *pbuf, UINT32 address, UINT32 len )
{
	UINT8 NumOfPage = 0, NumOfSingle = 0, Addr = 0, count = 0, temp = 0;

	Addr = address % SPI_FLASH_PageSize;
	count = SPI_FLASH_PageSize - Addr;
	NumOfPage =  len / SPI_FLASH_PageSize;
	NumOfSingle = len % SPI_FLASH_PageSize;

	if( Addr == 0 ) 															/* WriteAddr is SPI_FLASH_PageSize aligned  */
	{
		if( NumOfPage == 0 ) 													/* NumByteToWrite < SPI_FLASH_PageSize */
		{
			W25XXX_WR_Page( pbuf, address, len );
		}
		else 																	/* NumByteToWrite > SPI_FLASH_PageSize */
		{
			while( NumOfPage-- )
			{
				W25XXX_WR_Page( pbuf, address, SPI_FLASH_PageSize );
				address +=  SPI_FLASH_PageSize;
				pbuf += SPI_FLASH_PageSize;
			}
			W25XXX_WR_Page( pbuf, address, NumOfSingle );
		}
	}
	else 																		/* WriteAddr is not SPI_FLASH_PageSize aligned  */
	{
		if( NumOfPage == 0 ) 													/* NumByteToWrite < SPI_FLASH_PageSize */
		{
			if( NumOfSingle > count ) 											/* (NumByteToWrite + WriteAddr) > SPI_FLASH_PageSize */
			{
				temp = NumOfSingle - count;
				W25XXX_WR_Page( pbuf, address, count );
				address +=  count;
				pbuf += count;
				W25XXX_WR_Page( pbuf, address, temp );
			}
			else
			{
				W25XXX_WR_Page( pbuf, address, len );
			}
		}
		else 																	/* NumByteToWrite > SPI_FLASH_PageSize */
		{
			len -= count;
			NumOfPage =  len / SPI_FLASH_PageSize;
			NumOfSingle = len % SPI_FLASH_PageSize;
			W25XXX_WR_Page( pbuf, address, count );
			address +=  count;
			pbuf += count;
			while( NumOfPage-- )
			{
				W25XXX_WR_Page( pbuf, address, SPI_FLASH_PageSize );
				address += SPI_FLASH_PageSize;
				pbuf += SPI_FLASH_PageSize;
			}
			if( NumOfSingle != 0 )
			{
				W25XXX_WR_Page( pbuf, address, NumOfSingle );
			}
		}
	}
}

/*******************************************************************************
* Function Name  : SST25XXX_WriteBlock
* Description    : 鷽ʽд(ٷʽ)
*			       ע: ڲͬоƬ,ܲ.SST25VF512B,ʽһ	
* Input          : address---׼д׵ַ
*				   length----׼дݳ
*				   *pbuf-----׼дĻַ
* Output         : None
* Return         : None
ٶȲԣд512ֽҪ3MS
		  д4KҪ24.5MS
*******************************************************************************/
void SST25XXX_WriteBlock( UINT32 address, UINT32 length, UINT8 *pbuf )
{
	UINT8  temp; 
	UINT32 i;	
	
	/* д֮ǰȴдʹ,ұдڲĵַ */
	FLASH_WriteEnable( );									 					/* дʹ */
	
	/* Auto Address Increment (AAI) Programʽ,д */	 
	PIN_FLASH_CS_LOW( );
	SPI_FLASH_SendByte( CMD_FLASH_AAI_WORD_PROG );		   		 				/* Ͷȡ */					
	SPI_FLASH_SendByte( (UINT8)( address >> 16 ) );     						/* ֽҪȡݵĵַ */					
	SPI_FLASH_SendByte( (UINT8)( address >> 8 ) );		 						/* ݵַֽ */					
	SPI_FLASH_SendByte( (UINT8) address );		   		 						/* ݵַֽ */
	SPI_FLASH_SendByte( *pbuf++ );								 				/* ͵һֽ */	
	SPI_FLASH_SendByte( *pbuf++ );								 				/* ͵һֽ */	
	PIN_FLASH_CS_HIGH( );

	do
	{
		temp=FLASH_ReadStatusReg( );	
	}while( temp & 0X01 );										 				/* ȴǰִ */

	for( i = 2; i < length; i = i + 2  )					 		 			/* ͺ */
	{
	    PIN_FLASH_CS_LOW( );
		SPI_FLASH_SendByte( CMD_FLASH_AAI_WORD_PROG );		   	 				/* д */
		SPI_FLASH_SendByte( *pbuf++ );								 			/*  */
		SPI_FLASH_SendByte( *pbuf++ );								 			/*  */
		PIN_FLASH_CS_HIGH( );

		/* ȴ */
		do
		{
			temp = FLASH_ReadStatusReg( );	
		}while( temp & 0X01 );										 			/* ȴǰִ */
	}

	/* д֮,رдʹ˳AAIģʽ */
	FLASH_WriteDisable( );	  								 					/* رдʹ */
	do
	{
		temp = FLASH_ReadStatusReg( );	
	}while( temp & 0X01 );										     			/* ȴǰִ */
}

/*******************************************************************************
* Function Name  : FLASH_WR_Block
* Description    : FLASHд(ע: ֻд1ҳ)
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/  
void FLASH_WR_Block( UINT32 address, UINT8 *pbuf, UINT32 len )
{
	/* W25ϵFLASHSSTϵFLASH */
	if( Flash_Type == DEF_TYPE_W25XXX )
	{
		W25XXX_WR_Block( pbuf, address, len );
	}
	else if( Flash_Type == DEF_TYPE_SST25XXX )
	{
		SST25XXX_WriteBlock( address, len, pbuf );
	}
	else
	{
		W25XXX_WR_Block( pbuf, address, len );
	}
}

/*******************************************************************************
* Function Name  : MT25QXX_ReadExAddrReg
* Description    : MT25QXXXоƬȡչַĴ
* Input          : None
* Output         : None
* Return         : ؼĴֵ
*******************************************************************************/
UINT8 MT25QXXX_ReadExAddrReg( void )
{
	UINT8  status;

	PIN_FLASH_CS_LOW( );
	SPI_FLASH_SendByte( CMD_RD_EX_ADDR_REG );
	status = SPI_FLASH_ReadByte( );
	PIN_FLASH_CS_HIGH( );
	return( status );
}

/*******************************************************************************
* Function Name  : MT25QXXX_WriteExAddrReg
* Description    : MT25QXXXоƬдչַĴ
* Input          : dat---ҪдļĴֵ
* Output         : None
* Return         : None
*******************************************************************************/
void MT25QXXX_WriteExAddrReg( UINT8 dat )
{
    PIN_FLASH_CS_LOW( );
 	SPI_FLASH_SendByte( CMD_FLASH_WREN );
 	PIN_FLASH_CS_HIGH( );

	PIN_FLASH_CS_LOW( );
 	SPI_FLASH_SendByte( CMD_WR_EX_ADDR_REG );
 	SPI_FLASH_SendByte( dat );
 	PIN_FLASH_CS_HIGH( );
}

/*******************************************************************************
* Function Name  : MT25QXXX_ChangeExAddrReg
* Description    : MT25QXXXоƬıչַĴ
* Input          : dat---ҪдļĴֵ
* Output         : None
* Return         : None
*******************************************************************************/
void MT25QXXX_ChangeExAddrReg( UINT8 dat )
{
	UINT8 ex_addr;

	ex_addr = MT25QXXX_ReadExAddrReg( );
	if( ex_addr != dat )
	{
		MT25QXXX_WriteExAddrReg( dat );
	}
}

/*******************************************************************************
* Function Name  : FLASH_IC_Check
* Description    : FLASHоƬ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void FLASH_IC_Check( void )
{
	UINT32 count;

	/* ȡFLASHоƬID */	
	Flash_ID = FLASH_ReadID( );													/* ȡFLASHID */
	printf("Flash_ID: %08lx\n",(UINT32)Flash_ID);

	/* оƬͺ,жС */
	Flash_Type = 0x00;																
	Flash_Sector_Count = 0x00;													/* FLASHоƬ */
	Flash_Sector_Size = 0x00;													/* FLASHоƬС */
#if 1
	switch( Flash_ID )
	{
		/**************************************************************************/
		/* W25XXXϵоƬ */
		case W25X10_FLASH_ID:            										/* 0xEF3011-----1M bit */
			count = 1;
			break;

		case W25X20_FLASH_ID:            										/* 0xEF3012-----2M bit */
			count = 2;
			break;

		case W25X40_FLASH_ID:                    								/* 0xEF3013-----4M bit */
			count = 4;
			break;

		case W25X80_FLASH_ID:                        							/* 0xEF4014-----8M bit */
			count = 8;
			break;

		case W25Q16_FLASH_ID1:                    								/* 0xEF3015-----16M bit */
		case W25Q16_FLASH_ID2:                    								/* 0xEF4015-----16M bit */
			count = 16;
			break;

		case W25Q32_FLASH_ID1:                    								/* 0xEF4016-----32M bit */
		case W25Q32_FLASH_ID2:                    								/* 0xEF6016-----32M bit */
			count = 32;
			break;

		case W25Q64_FLASH_ID1:                    								/* 0xEF4017-----64M bit */
		case W25Q64_FLASH_ID2:                    								/* 0xEF6017-----64M bit */
			count = 64;
			break;

		case W25Q128_FLASH_ID1:                   								/* 0xEF4018-----128M bit */
		case W25Q128_FLASH_ID2:                   								/* 0xEF6018-----128M bit */
			count = 128;
			break;

		case W25Q256_FLASH_ID1:                   								/* 0xEF4019-----256M bit */
		case W25Q256_FLASH_ID2:                   								/* 0xEF6019-----256M bit */
			count = 256;
			break;

		/**************************************************************************/
		/* SST25XXXϵоƬ */
        case SST25VF040_FLASH_ID:                                               /* 0xBF258D-----4M bit */
            count = 4;
            Flash_Type = DEF_TYPE_SST25XXX;
            break;

        case SST25VF080_FLASH_ID:                                               /* 0xBF258E-----8M bit */
            count = 8;
            Flash_Type = DEF_TYPE_SST25XXX;                                     /* FLASHоƬ: 0: W25ϵ; 1: SSTϵ */
            break;

		case SST25VF016_FLASH_ID:           									/* 0xBF254A-----16M bit */
			count = 16;
			Flash_Type = DEF_TYPE_SST25XXX;										/* FLASHоƬ: 0: W25ϵ; 1: SSTϵ */
			break;

		case SST25VF032_FLASH_ID:           									/* 0xBF254A-----32M bit */
			count = 32;
			Flash_Type = DEF_TYPE_SST25XXX;										/* FLASHоƬ: 0: W25ϵ; 1: SSTϵ */
			break;

		case SST25VF064_FLASH_ID:           									/* 0xBF254B-----64M bit */
			count = 64;
			Flash_Type = DEF_TYPE_SST25XXX;										/* FLASHоƬ: 0: W25ϵ; 1: SSTϵ */
			break;

	        /**************************************************************************/
			/* M25PXXXϵ */
        case M25P40_FLASH_ID:                                                   /* 4M bit */
            count = 4;
            Flash_Type = DEF_TYPE_M25PXXX;
            break;

        case M25P80_FLASH_ID:                                                   /* 8M bit */
            count = 8;
            Flash_Type = DEF_TYPE_M25PXXX;
            break;

        case M25P16_FLASH_ID:                                                   /* 16M bit */
            count = 16;
            Flash_Type = DEF_TYPE_M25PXXX;
            break;

        case M25P32_FLASH_ID:                                                   /* 32M bit */
            count = 32;
            Flash_Type = DEF_TYPE_M25PXXX;
            break;

        case M25P64_FLASH_ID:                                                   /* 64M bit */
            count = 64;
            Flash_Type = DEF_TYPE_M25PXXX;
            break;

            /**************************************************************************/
            /* MX25LXXXϵ */
        case MX25L40_FLASH_ID:                                                  /* 4M bit */
            count = 4;
            Flash_Type = DEF_TYPE_MX25LXXX;
            break;

        case MX25L80_FLASH_ID:                                                  /* 8M bit */
            count = 8;
            Flash_Type = DEF_TYPE_MX25LXXX;
            break;

        case MX25L16_FLASH_ID:                                                  /* 16M bit */
            count = 16;
            Flash_Type = DEF_TYPE_MX25LXXX;
            break;

        case MX25L32_FLASH_ID:                                                  /* 32M bit */
            count = 32;
            Flash_Type = DEF_TYPE_MX25LXXX;
            break;

        case MX25L64_FLASH_ID:                                                  /* 64M bit */
            count = 64;
            Flash_Type = DEF_TYPE_MX25LXXX;
            break;

			/**************************************************************************/
			/* MT25QXXϵоƬ */
		case MT25Q_FLASH_64Mb:           										/* 0x20BA17-----64M bit */
			count = 64;
			Flash_Type = DEF_TYPE_MT25QXXX;
			break;

		case MT25Q_FLASH_128Mb:           										/* 0x20BA18-----128M bit */
			count = 128;
			Flash_Type = DEF_TYPE_MT25QXXX;
			break;

		case MT25Q_FLASH_256Mb:           										/* 0x20BA19-----256M bit */
			count = 256;
			Flash_Type = DEF_TYPE_MT25QXXX;
			break;

		case MT25Q_FLASH_512Mb:           										/* 0x20BA20-----512M bit */
			count = 512;
			Flash_Type = DEF_TYPE_MT25QXXX;
			break;

		case MT25Q_FLASH_1024Mb:           										/* 0x20BA21-----1G bit */
			count = 1024;
			Flash_Type = DEF_TYPE_MT25QXXX;
			break;

		case MT25Q_FLASH_2048Mb:           										/* 0x20BA22-----2G bit */
			count = 2048;
			Flash_Type = DEF_TYPE_MT25QXXX;
			break;

 		default:
 		    if( ( Flash_ID != 0xFFFFFFFF ) || ( Flash_ID != 0x00000000 ) )
 		    {
 		       count = 16;
 		    }
 		    else
 		    {
 	            count = 0x00;
            }
			break;
	}
	count = ( (UINT32)count * 1024 ) * ( (UINT32)1024 / 8 );
#endif

#if 0
    if( ( Flash_ID != 0xFFFFFFFF ) || ( Flash_ID != 0x00000000 ) )
    {
       count = 8;
    }
    else
    {
        count = 0x00;
    }
    count = ( (UINT32)count * 1024 ) * ( (UINT32)1024 / 8 );
#endif

	/* ݲͬоƬ⴦ */
	if( Flash_Type == DEF_TYPE_SST25XXX )
	{
		FLASH_ReadStatusReg( );
		FLASH_WriteStatusReg( 0x00 );			   				  	 			/* ״̬Ĵеλ:BP0BP1BP2,FLASHвд */
		FLASH_ReadStatusReg( );
	}

	/* FLASHоƬĿ,СϢ */
	if( count )
	{
		Flash_Sector_Count = count / DEF_UDISK_SECTOR_SIZE;						/* FLASHоƬ */
		Flash_Sector_Size = DEF_UDISK_SECTOR_SIZE;								/* FLASHоƬС */
	}
}

