/********************************** (C) COPYRIGHT *******************************
* File Name          : SW_UDISK.H
* Author             : MJX
* Version            : V1.00
* Date               : 2021/08/01
* Description        : Uض,롢Ϣؽṹ
*******************************************************************************/

#include "stdio.h"
#include "stdlib.h"

/******************************************************************************/
/* BulkOnly Mass Storage豸 */
#define CMD_UDISK_RESET                 0xFF  					 				/* λU */
#define CMD_UDISK_GET_MAX_LUN           0xFE  					 				/* ȡU߼ */

/******************************************************************************/
/* USB Mass Storage Class SCSI Command */
#define CMD_U_TEST_READY              	0x00  					 				/* UFIUǷ׼ */
#define CMD_U_REZERO_UNIT             	0x01  					 				/* UFIͷص0ŵ */
#define CMD_U_REQUEST_SENSE           	0x03  					 				/* UFI */
#define CMD_U_FORMAT_UNIT             	0x04  					 				/* UFIʽ */
#define CMD_U_INQUIRY             		0x12  					 				/* UFIѯ */
#define CMD_U_MODE_SELECT             	0x15  					 				/* UFI */
#define CMD_U_RELEASE	             	0x17  							 		/* UFI */
#define CMD_U_MODE_SENSE	            0x1A  					 				/* UFI */
#define CMD_U_START_STOP	            0x1B  					 				/* UFI */
#define CMD_U_SEND_DIAG	  	 	        0x1D  					 				/* UFI */
#define CMD_U_PREVT_REMOVE	  	 	    0x1E  					 				/* UFI ֹýƳ */
#define CMD_U_READ_FORMAT_CAPACITY	  	0x23  					 				/* UFI ȡʽ */
#define CMD_U_READ_CAPACITY	  			0x25  					 				/* UFI ȡ */
#define CMD_U_READ10	  				0x28  					 				/* UFI ݿ */
#define CMD_U_WRITE10	  				0x2A  					 				/* UFI дݿ */
#define CMD_U_SEEK10	  				0x2B  					 				/* UFI */
#define CMD_U_WR_VERIFY10	  			0x2E  					 				/* UFI дݿ鲢У */
#define CMD_U_VERIFY10	  				0x2F  					 				/* UFI 鲢У */
#define CMD_U_SYNC_CACHE	  			0x35  					 				/* UFI */
#define CMD_U_READ_TOC	  				0x43  					 				/* UFI*/
#define CMD_U_MODE_SENSE2	  			0x5A  						 			/* UFI*/
#define CMD_U_READ12	  				0xA8  					 				/* UFI ݿ */
#define CMD_U_WRITE12	  				0xAA  					 				/* UFI дݿ */

/******************************************************************************/
/* ָǰСU̴СΪ32K */
#define MY_UDISK_SIZE  0x00000040								 				/* СUС: 64 * 512B = 32k */

/******************************************************************************/
/* BulkOnlyṹ */
typedef union _BULK_ONLY_CMD 
{
	UINT8 buf[ 31 ];
	struct 
	{
		UINT8 mCBW_Sig[ 4 ];									 				/* CBWʶ־'USBC' */
		UINT8 mCBW_Tag[ 4 ];									 				/* ǩ */
		UINT8 mCBW_DataLen[ 4 ];								 				/* ݴ䳤 */
		UINT8 mCBW_Flag;										 				/* D7λʾݷ,0=out,1=in,λΪ0 */
		UINT8 mCBW_LUN;											 				/* ո߼ԪLUN */
		UINT8 mCBW_CB_Len;										 				/* ĳ,Чֵ116 */
		UINT8 mCBW_CB_Buf[ 16 ];								 				/* ,ûΪ16ֽ */
	} mCBW;														 				/* BulkOnlyЭ,CBWṹ */
	struct
	{
		UINT8 mCSW_Sig[ 4 ];								 	 				/* ״̬CSWʶ־'USBS' */
		UINT8 mCSW_Tag[ 4 ];									 				/* ǩ */
		UINT8 mCSW_Residue[ 4 ];								 				/* ʾdCBWDataTransferLenhthֶϣݳʵʷ͵ݳȵĲ */
		UINT8 mCSW_Status;										 				/* ִн״̬ */
	} mCSW;														 				/* BulkOnlyЭ״̬,CSWṹ */
	struct 
	{
		UINT8 ErrorCode;
		UINT8 Reserved1;		
		UINT8 SenseKey;
		UINT8 Information[ 4 ];
		UINT8 SenseLength;
		UINT8 Reserved2[ 4 ];
		UINT8 SenseCode;
		UINT8 SenseCodeQua;
		UINT8 Reserved3[ 4 ];
	}ReqSense;												 
} BULK_ONLY_CMD;

/******************************************************************************/
/* ǰUغ궨(Ҫ޸) */
#define DEF_CFG_DISK_SEC_SIZE      4096                                         /* С */

#define DEF_FLASH_SECTOR_SIZE  	   4096											/* FLASHС */
#define DEF_UDISK_SECTOR_SIZE  	   DEF_CFG_DISK_SEC_SIZE						/* UС */
#define DEF_UDISK_PACK_512    	   512											/* ṴС() */
#define DEF_UDISK_PACK_64          64                                           /* ṴС(ȫ) */

/* FLASHоƬUݿռռÿռ䶨壬һռ64Kռ */
#if( DEF_CFG_DISK_SEC_SIZE == DEF_FLASH_SECTOR_SIZE )
#define DEF_FLASH_BACKUP_SEC_NUM   16 											/* FLASHĿ(16FLASH) */
#define DEF_FLASH_COPY_SEC_NUM     8                                            /* FLASHĿ(8FLASH) */
#define DEF_FLASH_RESERVE_BLOCK    4
#else
#define DEF_FLASH_BACKUP_SEC_NUM   128 											/* FLASHĿ(16FLASH) */
#define DEF_FLASH_COPY_SEC_NUM     64                                           /* FLASHĿ(8FLASH) */
#endif

/******************************************************************************/
/* ǰU״̬غ궨 */
#define DEF_UDISK_EN_FLAG          0x01											/* Uʹ״̬:   0: δʹ;   1: ʹ */
#define DEF_UDISK_WP_FLAG          0x02											/* Uд״̬: 0: δд; 1: д */
#define DEF_UDISK_CDROM_FLAG       0x04                                         /* UCDROM״̬: 0: Uģʽ; 1: CDROMģʽ */

/******************************************************************************/
/* ǰU̴״̬غ궨 */
#define DEF_UDISK_BLUCK_UP_FLAG    0x01											/* Uϴݱ־ */
#define DEF_UDISK_BLUCK_DOWN_FLAG  0x02											/* U´ݱ־ */
#define DEF_UDISK_CSW_UP_FLAG  	   0x04											/* UδϴCSW־ */

/******************************************************************************/
/*  */
extern UINT8V  Udisk_CBW_Tag_Save[ 4 ];										 	/* U̵dCBWTagǩݴ */
extern UINT8V  Udisk_Sense_Key;												 	/* U̴ϸϢ */
extern UINT8V  Udisk_Sense_ASC;												 	/* ̴ϸϢĴμ */
extern UINT8V  Udisk_CSW_Status;												/* ǰִн״̬(0; 1һ磺ʧ//֧; 2:ش,ݲͬ,) */

extern UINT32V UDISK_Transfer_DataLen;										 	/* ǰҪдĳ */
extern UINT32V UDISK_Cur_Sec_Lba;											 	/* ǰвLBAַ */
extern UINT16V UDISK_Sec_Pack_Count;											/* ÿ(һ8) */
extern UINT16V UDISK_Pack_Size;                                                 /* ṴС64/512 */

extern BULK_ONLY_CMD	mBOC;								 		 		    /* BulkOnlyṹ */

extern UINT8V  Udisk_Status;													/* U״̬״̬ */
extern UINT8V  Udisk_Transfer_Status;											/* U̴״̬ */
extern UINT32V Udisk_Capability;												/* U̸ʽ */

extern UINT8  UDISK_Inquity_Tab[ ];						        				/* INQUITYϢ */
extern UINT8  const  UDISK_Rd_Format_Capacity[ ];								/* ʽϢ */
extern UINT8  const  UDISK_Rd_Capacity[ ];										/* Ϣ */
extern UINT8  const  UDISK_Mode_Sense_1A[ ];								    /* MODE_SENSEϢ,0X1A */
extern UINT8  const  UDISK_Mode_Senese_5A[ ];									/* MODE_SENSEϢ,0X5A */

/******************************************************************************/
/*  */
extern void UDISK_CMD_Deal_Status( UINT8 key, UINT8 asc, UINT8 status );		/* ǰUִ״̬ */
extern void UDISK_CMD_Deal_Fail( void );										/* ǰUִʧ */
extern void UDISK_SCSI_CMD_Deal( void );										/* SCSI */
extern void UDISK_Bulk_UpData( void );											/* ˵˵2ϴݰ */
extern void UDISK_Up_CSW( void );												/* ˵˵2ϴCSW */
extern void UDISK_Up_OnePack( void );											/* U̴һϴ */
extern void UDISK_Out_EP_Deal( UINT8 *pbuf, UINT16 packlen );					/* U̴һ´ */
extern void UDISK_In_EP_Deal( void );
extern void UDISK_Down_OnePack( UINT8 *pbuf, UINT16 packlen );
