/********************************** (C) COPYRIGHT *******************************
* File Name          : SW_UDISK.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/08/01
* Description        : ģU(FLASHΪ洢)ֳ
*					   ǰUÿΪ512ֽ,FLASHǰָΪʱ;
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "ch32v30x_usbhs_device.h"
#include "ch32v30x_spi.h"
#include "SPI_FLASH.H"
#include "SW_UDISK.H"

/******************************************************************************/
/*  */
#define DEF_DEBUG_PRINTF           0

/******************************************************************************/
/* INQUITYϢ */
UINT8 UDISK_Inquity_Tab[ ] =
{
    /* UDISK */
    0x00,                                                                       /* Peripheral Device TypeUDISK=0x00,CD-ROM=0x05 */
    0x80,                                                                       /* Ƴ */
    0x02,                                                                       /* ISO/ECMA */
    0x02,

    0x1F,                                                                       /* Additional Length */
    0x00,                                                                       /* Reserved */
    0x00,                                                                       /* Reserved */
    0x00,                                                                       /* Reserved */
    'F',                                                                        /* Vendor Information */
    'l',
    'a',
    's',
    'h',
    ' ',
    ' ',
    ' ',
    'U',                                                                        /* Product Identification */
    'S',
    'B',
    ' ',
    'S',
    'p',
    'e',
    'c',
    'i',
    'a',
    'l',
    ' ',
    'D',
    'i',
    's',
    'k',
    '2',                                                                        /* Product Revision Level */
    '.',
    'D',
    '0'
};

/******************************************************************************/
/* ʽϢ */
UINT8  const  UDISK_Rd_Format_Capacity[ ] =
{
    0x00,
    0x00,
    0x00,
    0x08,
    ( MY_UDISK_SIZE >> 24 ) & 0xFF,
    ( MY_UDISK_SIZE >> 16 ) & 0xFF,
    ( MY_UDISK_SIZE >> 8 ) & 0xFF,
    ( MY_UDISK_SIZE ) & 0xFF,
    0x02,
    ( DEF_CFG_DISK_SEC_SIZE >> 16 ) & 0xFF,                                     /* Number of Blocks */
    ( DEF_CFG_DISK_SEC_SIZE >> 8 ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE ) & 0xFF,
};

/******************************************************************************/
/* Ϣ */
UINT8  const  UDISK_Rd_Capacity[ ] =
{
    ( ( MY_UDISK_SIZE - 1 ) >> 24 ) & 0xFF,
    ( ( MY_UDISK_SIZE - 1 ) >> 16 ) & 0xFF,
    ( ( MY_UDISK_SIZE - 1 ) >> 8 ) & 0xFF,
    ( ( MY_UDISK_SIZE - 1 ) ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE >> 24 ) & 0xFF,                                     /* Number of Blocks */
    ( DEF_CFG_DISK_SEC_SIZE >> 16 ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE >> 8 ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE ) & 0xFF,
};

/******************************************************************************/
/* MODE_SENSEϢ,0X1A */
UINT8  const  UDISK_Mode_Sense_1A[ ] =
{
    0x0B,
    0x00,
    0x00,                                                                       /* 0x00:δд,0x80:д */
    0x08,
    ( ( MY_UDISK_SIZE - 1 ) >> 24 ) & 0xFF,
    ( ( MY_UDISK_SIZE - 1 )  >> 16 ) & 0xFF,
    ( ( MY_UDISK_SIZE - 1 )  >> 8 ) & 0xFF,
    ( ( MY_UDISK_SIZE - 1 )  ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE >> 24 ) & 0xFF,                                     /* Number of Blocks */
    ( DEF_CFG_DISK_SEC_SIZE >> 16 ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE >> 8 ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE ) & 0xFF,
};

/******************************************************************************/
/* MODE_SENSEϢ,0X5A */
UINT8  const  UDISK_Mode_Senese_5A[ ] =
{
    0x00,
    0x0E,
    0x00,
    0x00,                                                                       /* 0x00:δд,0x80:д */
    0x00,
    0x00,
    0x00,
    0x08,
    ( ( MY_UDISK_SIZE - 1 ) >> 24 ) & 0xFF,
    ( ( MY_UDISK_SIZE - 1 )  >> 16 ) & 0xFF,
    ( ( MY_UDISK_SIZE - 1 )  >> 8 ) & 0xFF,
    ( ( MY_UDISK_SIZE - 1 )  ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE >> 24 ) & 0xFF,                                     /* Number of Blocks */
    ( DEF_CFG_DISK_SEC_SIZE >> 16 ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE >> 8 ) & 0xFF,
    ( DEF_CFG_DISK_SEC_SIZE ) & 0xFF,
};


UINT8V  Udisk_Status = 0x00;													/* U״̬ */
UINT8V  Udisk_Transfer_Status = 0x00;											/* U̴״̬ */
UINT32V Udisk_Capability = 0x00;												/* U̸ʽ */
UINT8V  Udisk_CBW_Tag_Save[ 4 ];										 		/* U̵dCBWTagǩݴ */
UINT8V  Udisk_Sense_Key = 0x00;												 	/* U̴ϸϢ */
UINT8V  Udisk_Sense_ASC = 0x00;												 	/* ̴ϸϢĴμ */
UINT8V  Udisk_CSW_Status = 0x00;												/* ǰִн״̬(0; 1һ磺ʧ//֧; 2:ش,ݲͬ,) */

UINT32V UDISK_Transfer_DataLen = 0x00;											/* ǰҪдĳ */
UINT32V UDISK_Cur_Sec_Lba = 0x00;											 	/* ǰвLBAַ */
UINT16V UDISK_Sec_Pack_Count = 0x00;											/* ÿ(һ8) */
UINT16V UDISK_Pack_Size = DEF_UDISK_PACK_512;                                   /* ṴС64/512 */

BULK_ONLY_CMD mBOC;									 		 			        /* BulkOnlyṹ */
UINT8   *pEndp2_Buf;															/* ˵2ϴݴַָ */

/*******************************************************************************
* Function Name  : UDISK_Data_USB_UpLoad
* Description    : ǰUִ״̬
* Input          : Uϴ
* Output         : None
* Return         : None
*******************************************************************************/
void UDISK_Data_USB_UpLoad( UINT8 *buf, UINT16 len )
{
    memcpy( &EP2_Tx_Databuf[ 0 ], buf, len );
    USBHSD->UEP2_TX_LEN  = len;
    USBHSD->UEP2_TX_CTRL ^= USBHS_EP_T_TOG_1;
    USBHSD->UEP2_TX_CTRL &= ~USBHS_EP_T_RES_MASK;
    USBHSD->UEP2_TX_CTRL |= USBHS_EP_T_RES_ACK;
}

/*******************************************************************************
* Function Name  : UDISK_CMD_Deal_Status
* Description    : ǰUִ״̬
* Input          : key------̴ϸϢ
*                  asc------̴ϸϢĴμ
*                  status---ǰִн״̬
* Output         : None
* Return         : None
*******************************************************************************/
void UDISK_CMD_Deal_Status( UINT8 key, UINT8 asc, UINT8 status )
{
	Udisk_Sense_Key  = key;								 			 			/* ̴ϸϢ0 */
	Udisk_Sense_ASC  = asc;								 		 	 			/* ̴ϸϢĴμ0 */
	Udisk_CSW_Status = status;								 			 		/* ǰִн״̬0 */			
}

/*******************************************************************************
* Function Name  : UDISK_CMD_Deal_Fail
* Description    : ǰUִʧ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UDISK_CMD_Deal_Fail( void )
{
	if( Udisk_Transfer_Status & DEF_UDISK_BLUCK_UP_FLAG )
	{
		/* ˵2ϴSTALL */
	    USBHSD->UEP2_TX_CTRL = ( USBHSD->UEP2_TX_CTRL & ~USBHS_EP_T_RES_MASK ) | USBHS_EP_T_RES_STALL;
		Udisk_Transfer_Status &= ~DEF_UDISK_BLUCK_UP_FLAG;
	}
	if( Udisk_Transfer_Status & DEF_UDISK_BLUCK_DOWN_FLAG )
	{
		/* ˵3´STALL */
	    USBHSD->UEP3_RX_CTRL = ( USBHSD->UEP3_RX_CTRL & ~USBHS_EP_T_RES_MASK ) | USBHS_EP_R_RES_STALL;
		Udisk_Transfer_Status &= ~DEF_UDISK_BLUCK_DOWN_FLAG;
	}
}

/*******************************************************************************
* Function Name  : CMD_RD_WR_Deal_Pre
* Description    : дǰ׼
*				        ҪΪ˽ʡ,źϲһе
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CMD_RD_WR_Deal_Pre( void )
{
	/* 浱ǰҪ */
	UDISK_Cur_Sec_Lba = (UINT32)mBOC.mCBW.mCBW_CB_Buf[ 2 ] << 24;
	UDISK_Cur_Sec_Lba = UDISK_Cur_Sec_Lba + ( (UINT32)mBOC.mCBW.mCBW_CB_Buf[ 3 ] << 16 );
	UDISK_Cur_Sec_Lba = UDISK_Cur_Sec_Lba + ( (UINT32)mBOC.mCBW.mCBW_CB_Buf[ 4 ] << 8 );
	UDISK_Cur_Sec_Lba = UDISK_Cur_Sec_Lba + ( (UINT32)mBOC.mCBW.mCBW_CB_Buf[ 5 ] );
		
	/* ı */
	UDISK_Cur_Sec_Lba += DEF_FLASH_BACKUP_SEC_NUM;
	UDISK_Cur_Sec_Lba += DEF_FLASH_RESERVE_BLOCK;

	/* 浱ǰҪݳ */					
	UDISK_Transfer_DataLen = ( (UINT32)mBOC.mCBW.mCBW_CB_Buf[ 7 ] << 8 );
	UDISK_Transfer_DataLen = UDISK_Transfer_DataLen + ( (UINT32)mBOC.mCBW.mCBW_CB_Buf[ 8 ] );
	UDISK_Transfer_DataLen = UDISK_Transfer_DataLen * DEF_UDISK_SECTOR_SIZE;	 	

	/* ر */
	UDISK_Sec_Pack_Count = 0x00;												/* ÿ(һ8) */											
	UDISK_CMD_Deal_Status( 0x00, 0x00, 0x00 );									/* ǰUִгɹ */
}

/*******************************************************************************
* Function Name  : UDISK_SCSI_CMD_Deal
* Description    : 
* Input          : 
* Output         : 
* Return         : None
*******************************************************************************/
void UDISK_SCSI_CMD_Deal( void )
{
	UINT8 i;

	if( ( mBOC.mCBW.mCBW_Sig[ 0 ] == 'U' ) && ( mBOC.mCBW.mCBW_Sig[ 1 ] == 'S' ) 
	  &&( mBOC.mCBW.mCBW_Sig[ 2 ] == 'B' ) && ( mBOC.mCBW.mCBW_Sig[ 3 ] == 'C' ) )	/* CBWİ־ȷ */
	{
		/* CBWеǩ,ԱϴCSWʱʹ */
		Udisk_CBW_Tag_Save[ 0 ] = mBOC.mCBW.mCBW_Tag[ 0 ];
		Udisk_CBW_Tag_Save[ 1 ] = mBOC.mCBW.mCBW_Tag[ 1 ];
		Udisk_CBW_Tag_Save[ 2 ] = mBOC.mCBW.mCBW_Tag[ 2 ];
		Udisk_CBW_Tag_Save[ 3 ] = mBOC.mCBW.mCBW_Tag[ 3 ];

 		/* CBWеĴ䳤,Աϴ´ʹ */
		UDISK_Transfer_DataLen = ( UINT32 )mBOC.mCBW.mCBW_DataLen[ 3 ] << 24;
		UDISK_Transfer_DataLen += ( ( UINT32 )mBOC.mCBW.mCBW_DataLen[ 2 ] << 16 );
		UDISK_Transfer_DataLen += ( ( UINT32 )mBOC.mCBW.mCBW_DataLen[ 1 ] << 8 );
		UDISK_Transfer_DataLen += ( ( UINT32 )mBOC.mCBW.mCBW_DataLen[ 0 ] );
		
		/* 䳤ȲΪ0,жϴ´ */
		if( UDISK_Transfer_DataLen )									 
		{
			if( mBOC.mCBW.mCBW_Flag & 0x80 )
			{
				Udisk_Transfer_Status |= DEF_UDISK_BLUCK_UP_FLAG;			  	/* ϴ־ */					 						
			}	
			else
			{	
				Udisk_Transfer_Status |= DEF_UDISK_BLUCK_DOWN_FLAG;				/* ´־ */		
			}
		}
		Udisk_Transfer_Status |= DEF_UDISK_CSW_UP_FLAG;		 					/* CSWδر־ */								 					
		
		/* USCSI */ 
#if	( DEF_DEBUG_PRINTF == 1 )	
		printf("CMD:%x\n",(UINT16)mBOC.mCBW.mCBW_CB_Buf[ 0 ] );
#endif

		/* е߼Ԫ,ֱд */
		/* ʹU,mBOC.mCBW.mCBW_LUNΪ0;
		        ʹA,mBOC.mCBW.mCBW_LUNΪ0;
		        ͬʱʹU̺A,mBOC.mCBW.mCBW_LUNΪ0ʱΪU,mBOC.mCBW.mCBW_LUNΪ1ʱΪA; */
		switch( mBOC.mCBW.mCBW_CB_Buf[ 0 ] )
		{
			case  CMD_U_INQUIRY:								 				/* : 0x12 */
				if( UDISK_Transfer_DataLen > 0x24 )
				{
					UDISK_Transfer_DataLen = 0x24;					 			/* InquiryϢΪ36ֽ */
				}	

				/* ϴFLASHоƬID */
				UDISK_Inquity_Tab[ 32 ] =  (UINT8)( Flash_ID >> 24 );
                UDISK_Inquity_Tab[ 33 ] =  (UINT8)( Flash_ID >> 16 );
                UDISK_Inquity_Tab[ 34 ] =  (UINT8)( Flash_ID >> 8 );
                UDISK_Inquity_Tab[ 35 ] =  (UINT8)( Flash_ID );

                /* жϵǰUģʽCDROMģʽ */
                if( Udisk_Status & DEF_UDISK_CDROM_FLAG )
                {
                    /* CD-ROMģʽ */
                    UDISK_Inquity_Tab[ 0 ] = 0x05;
                }
                else
                {
                    /* UDISKģʽ */
                    UDISK_Inquity_Tab[ 0 ] = 0x00;
                }
				pEndp2_Buf = (UINT8 *)UDISK_Inquity_Tab;									
				UDISK_CMD_Deal_Status( 0x00, 0x00, 0x00 );						/* ǰUִгɹ */	
				break;
	
			case  CMD_U_READ_FORMAT_CAPACITY:					 				/* : 0x23 */
				if( ( Udisk_Status & DEF_UDISK_EN_FLAG ) )                      /* жϵǰ洢Ƿ */
				{	
					if( UDISK_Transfer_DataLen > 0x0C )
					{
						UDISK_Transfer_DataLen = 0x0C;				 			/* FORMAT_CAPACITYϢΪ12ֽ */
					}	
									
					for( i = 0x00; i < UDISK_Transfer_DataLen; i++ )
					{
						mBOC.buf[ i ] = UDISK_Rd_Format_Capacity[ i ];		/* ָָFORMAT_CAPACITY */
					} 
					mBOC.buf[ 4 ] = ( ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 24 ) & 0xFF ); 
					mBOC.buf[ 5 ] = ( ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 16 ) & 0xFF ); 
					mBOC.buf[ 6 ] = ( ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 8 ) & 0xFF );
					mBOC.buf[ 7 ] = ( ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) ) & 0xFF );
					pEndp2_Buf = mBOC.buf;					 		 			/* ָָmBOC.buf */	
					UDISK_CMD_Deal_Status( 0x00, 0x00, 0x00 );					/* ǰUִгɹ */	
				}
				else
				{
					UDISK_CMD_Deal_Status( 0x02, 0x3A, 0x01 );					/* 浱ǰ */
					UDISK_CMD_Deal_Fail( );						 				/* ǰUִʧ */						
				}	
				break;

			case  CMD_U_READ_CAPACITY:						 	 				/* : 0x25 */
				if( ( Udisk_Status & DEF_UDISK_EN_FLAG ) )						/* жϵǰ洢Ƿ */	
				{	
					if( UDISK_Transfer_DataLen > 0x08 )
					{
						UDISK_Transfer_DataLen = 0x08;				 			/* CAPACITYϢΪ8ֽ */
					}	
												
					for( i = 0x00; i < UDISK_Transfer_DataLen; i++ )
					{
						mBOC.buf[ i ] = UDISK_Rd_Capacity[ i ];	
					} 
					mBOC.buf[ 0 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 24 ) & 0xFF;
					mBOC.buf[ 1 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 16 ) & 0xFF; 
					mBOC.buf[ 2 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 8 ) & 0xFF;
					mBOC.buf[ 3 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) ) & 0xFF;

					pEndp2_Buf = mBOC.buf;					 		 			/* ָָmBOC.buf */	
					UDISK_CMD_Deal_Status( 0x00, 0x00, 0x00 );					/* ǰUִгɹ */
				}
				else
				{
					UDISK_CMD_Deal_Status( 0x02, 0x3A, 0x01 );					/* 浱ǰ */
					UDISK_CMD_Deal_Fail( );						 				/* ǰUִʧ */						
				}	
				break;

			case  CMD_U_READ10:									 				/* : 0x28 */
				if( ( Udisk_Status & DEF_UDISK_EN_FLAG ) ) 						/* жϵǰ洢Ƿ */	
				{					
					CMD_RD_WR_Deal_Pre( );										/* дǰ׼ */	
				}
				else
				{
					UDISK_CMD_Deal_Status( 0x02, 0x3A, 0x01 );					/* 浱ǰ */
					UDISK_CMD_Deal_Fail( );						 				/* ǰUִʧ */						
				}	
				break;
	
			case  CMD_U_WR_VERIFY10:							 				/* : 0x2E */
			case  CMD_U_WRITE10:								 				/* : 0x2A */
				if( Udisk_Status & DEF_UDISK_EN_FLAG )							/* жϵǰ洢Ƿ */	
				{		
					/* жϵǰǷʹд */
					if( Udisk_Status & DEF_UDISK_WP_FLAG )
					{
						UDISK_CMD_Deal_Status( 0x07, 0x27, 0x01 );				/* 浱ǰд */
						UDISK_CMD_Deal_Fail( );					 				/* ǰUִʧ */
						break;						
					}					
					else
					{
						CMD_RD_WR_Deal_Pre( );									/* дǰ׼ */	
					}
				}
				else
				{
					UDISK_CMD_Deal_Status( 0x02, 0x3A, 0x01 );					/* 浱ǰ */					
					UDISK_CMD_Deal_Fail( );						 				/* ǰUִʧ */						
				}				
				break;
	
			case  CMD_U_MODE_SENSE:								 				/* : 0x1A */
				if( ( Udisk_Status & DEF_UDISK_EN_FLAG ) )
				{	
					if( UDISK_Transfer_DataLen > 0x0C )
					{
						UDISK_Transfer_DataLen = 0x0C;			     			/* MODE_SENSEϢΪ12ֽ */
					}
					
					for( i = 0x00; i < UDISK_Transfer_DataLen; i++ )
					{
						mBOC.buf[ i ] = UDISK_Mode_Sense_1A[ i ];	
					} 
					if( Udisk_Status & DEF_UDISK_WP_FLAG )
					{
						mBOC.buf[ 2 ] = 0x80;					 			/* U̴洢д */	 
					}
					mBOC.buf[ 4 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 24 ) & 0xFF;
					mBOC.buf[ 5 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 16 ) & 0xFF; 
					mBOC.buf[ 6 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 8 ) & 0xFF;
					mBOC.buf[ 7 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) ) & 0xFF;

					pEndp2_Buf = mBOC.buf;					 		 			/* ָָmBOC.buf */						
				}
				else
				{
					UDISK_CMD_Deal_Status( 0x02, 0x3A, 0x01 );					/*  */
					UDISK_CMD_Deal_Fail( );						 				/* ǰUִʧ */					
				}
				break;

			case  CMD_U_MODE_SENSE2:							 				/* : 0x5A */
				if( mBOC.mCBW.mCBW_CB_Buf[ 2 ] == 0x3F )
				{	
					if( UDISK_Transfer_DataLen > 0x10 )
					{
						UDISK_Transfer_DataLen = 0x10;			     			/* MODE_SENSEϢΪ12ֽ */
					}

					for( i = 0x00; i < UDISK_Transfer_DataLen; i++ )
					{
						mBOC.buf[ i ] = UDISK_Mode_Senese_5A[ i ];	
					} 
					mBOC.buf[ 8 ]  = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) >> 24 ) & 0xFF;
					mBOC.buf[ 9 ]  = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM )  >> 16 ) & 0xFF; 
					mBOC.buf[ 10 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM )  >> 8 ) & 0xFF;
					mBOC.buf[ 11 ] = ( ( Udisk_Capability - DEF_FLASH_BACKUP_SEC_NUM ) ) & 0xFF;

					if( Udisk_Status & DEF_UDISK_WP_FLAG )
					{
						mBOC.buf[ 3 ] = 0x80;					 				/* U̴洢д */	 
					}
					pEndp2_Buf = mBOC.buf;					 		 			/* ָָmBOC.buf */						
				}
				else
				{
					UDISK_CMD_Deal_Status( 0x05, 0x20, 0x01 );					/*  */
					UDISK_CMD_Deal_Fail( );						 				/* ǰUִʧ */					
				}
				break;
	
			case  CMD_U_REQUEST_SENSE:						 	 				/* : 0x03 */
				mBOC.ReqSense.ErrorCode = 0x70;
				mBOC.ReqSense.Reserved1 = 0x00;
				mBOC.ReqSense.SenseKey  = Udisk_Sense_Key;			 			/* ̴ϸϢװ */ 
				mBOC.ReqSense.Information[ 0 ] = 0x00;
				mBOC.ReqSense.Information[ 1 ] = 0x00;
				mBOC.ReqSense.Information[ 2 ] = 0x00;
				mBOC.ReqSense.Information[ 3 ] = 0x00;
				mBOC.ReqSense.SenseLength = 0x0A;
				mBOC.ReqSense.Reserved2[ 0 ] = 0x00;
				mBOC.ReqSense.Reserved2[ 1 ] = 0x00;
				mBOC.ReqSense.Reserved2[ 2 ] = 0x00;
				mBOC.ReqSense.Reserved2[ 3 ] = 0x00;
				mBOC.ReqSense.SenseCode = Udisk_Sense_ASC;			 			/* ̴ϸϢĴμװ */
				mBOC.ReqSense.SenseCodeQua = 0x00;
				mBOC.ReqSense.Reserved3[ 0 ] = 0x00;
				mBOC.ReqSense.Reserved3[ 1 ] = 0x00;
				mBOC.ReqSense.Reserved3[ 2 ] = 0x00;
				mBOC.ReqSense.Reserved3[ 3 ] = 0x00;
				pEndp2_Buf = mBOC.buf;					 			 		    /* ָָmBOC.buf */
				Udisk_CSW_Status = 0x00;
				break;

			case  CMD_U_TEST_READY:								 				/* : 0x00 */				
				if( Udisk_Status & DEF_UDISK_EN_FLAG )
				{	
					UDISK_CMD_Deal_Status( 0x00, 0x00, 0x00 );					/* ǰUִгɹ */						
				}
				else
				{
					UDISK_CMD_Deal_Status( 0x02, 0x3A, 0x01 );					/* 浱ǰ */					
					Udisk_Transfer_Status |= DEF_UDISK_BLUCK_UP_FLAG;			/* Ԥϴ־ */	
					UDISK_CMD_Deal_Fail( );						 				/* ǰUִʧ */					
				}
				break;
	
			case  CMD_U_PREVT_REMOVE:							 				/* : 0x1E */
				UDISK_CMD_Deal_Status( 0x00, 0x00, 0x00 );						/* ǰUִгɹ */						
				break;
	
			case  CMD_U_VERIFY10:							 	 				/* : 0x1F */
				UDISK_CMD_Deal_Status( 0x00, 0x00, 0x00 );						/* ǰUִгɹ */						
				break;
				
			case  CMD_U_START_STOP:							 	 				/* : 0x1B */
				UDISK_CMD_Deal_Status( 0x00, 0x00, 0x00 );						/* ǰUִгɹ */						
				break;

			case  0x04:									 						/* ʽ */
				UDISK_CMD_Deal_Status( 0x00, 0x00, 0x00 );						/* ǰUִгɹ */		
				break;

			default:
				UDISK_CMD_Deal_Status( 0x05, 0x20, 0x01 );						/*  */
				Udisk_Transfer_Status |= DEF_UDISK_BLUCK_UP_FLAG;				/* Ԥϴ־ */	
				UDISK_CMD_Deal_Fail( );						 	 				/* ǰUִʧ */
				break;
		}
	}	
	else														 				/* CBWİ־ */
	{	
		UDISK_CMD_Deal_Status( 0x05, 0x20, 0x02 );								/* 浱ǰش */
		Udisk_Transfer_Status |= DEF_UDISK_BLUCK_UP_FLAG;
		Udisk_Transfer_Status |= DEF_UDISK_BLUCK_DOWN_FLAG;			 			/* ԤԱ㱨 */
		UDISK_CMD_Deal_Fail(  );
	}
}

/*******************************************************************************
* Function Name  : UDISK_In_EP_Deal
* Description    : Uϴ˵㴦
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UDISK_In_EP_Deal( void )
{		
	if( Udisk_Transfer_Status & DEF_UDISK_BLUCK_UP_FLAG ) 
	{
		if( mBOC.mCBW.mCBW_CB_Buf[ 0 ] == CMD_U_READ10 )
		{
			UDISK_Up_OnePack( );												/* ϴ64/512ֽ */
		}
		else
		{
			UDISK_Bulk_UpData( );		    		 	 						/* ˵ϴһ */
		}
	}
	else if( Udisk_Transfer_Status & DEF_UDISK_CSW_UP_FLAG )
	{	
		UDISK_Up_CSW( );								 						/* ϴCSW */
	}
}

/*******************************************************************************
* Function Name  : UDISK_Out_EP_Deal
* Description    : U´˵㴦
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UDISK_Out_EP_Deal( UINT8 *pbuf, UINT16 packlen )
{
	UINT32 i;

	/* ж˵2´ݴ */
	if( Udisk_Transfer_Status & DEF_UDISK_BLUCK_DOWN_FLAG )					 	/* дݽ׶,,д洢 */
	{
		/* ´USBݰ */
		UDISK_Down_OnePack( pbuf, packlen );									/* U(SD)һ´ */	 
	}
	else												 						/* ´,жǷǽյCBW */
	{								
		if( packlen == 0x1F )
		{
			for( i = 0; i < packlen; i++ ) 
			{
				mBOC.buf[ i ] = *pbuf++;	 									/* ݶ뵽 */
			}

			/* SCSIĴ */
			UDISK_SCSI_CMD_Deal( );					     						/* USCSI */				
			if( ( Udisk_Transfer_Status & DEF_UDISK_BLUCK_DOWN_FLAG ) == 0x00 )	/* ǰ´״̬ */		
			{
				if( Udisk_Transfer_Status & DEF_UDISK_BLUCK_UP_FLAG )			/* ǰΪϴ */		
				{
					if( mBOC.mCBW.mCBW_CB_Buf[ 0 ] == CMD_U_READ10 )
					{
						UDISK_Up_OnePack( );									/* U(SD)һϴ */
					}
					else
					{
						UDISK_Bulk_UpData( );		     						/* ˵ϴһ */
					}
				}
				else if( Udisk_CSW_Status == 0x00 )			 					/* ϴ,ҵǰִгɹ,CSW */
				{
					/* ϴCSW */
					UDISK_Up_CSW(  );					 
				}						
			}
		}
	}
}

/*******************************************************************************
* Function Name  : UDISK_Bulk_UpData
* Description    : ˵˵2ϴݰ
* Input          : Transfer_DataLen--- ݳ
*                  *pBuf---ݵַָ
* Output         : Transfer_DataLen--- ݳ
*                  *pBuf---ݵַָ
* Return         : None
*******************************************************************************/
void UDISK_Bulk_UpData( void )
{											
	UINT32  len;

	if( UDISK_Transfer_DataLen > UDISK_Pack_Size )							    /* 䳤ȴڰֵ,ǰϴֽ */
	{
		len = UDISK_Pack_Size;
		UDISK_Transfer_DataLen -= UDISK_Pack_Size;
	}
	else 														 				/* 䳤Сڵڰֵ,ʵʳϴ */	
	{
		len = UDISK_Transfer_DataLen;
		UDISK_Transfer_DataLen = 0x00;
		Udisk_Transfer_Status &= ~DEF_UDISK_BLUCK_UP_FLAG;		
	}

	/* װؽϴ,ϴ */
	memcpy( &EP2_Tx_Databuf[ 0 ], pEndp2_Buf, len );
    USBHSD->UEP2_TX_LEN  = len;
    USBHSD->UEP2_TX_CTRL &= ~USBHS_EP_T_RES_MASK;
    USBHSD->UEP2_TX_CTRL |= USBHS_EP_T_RES_ACK;
}

/*******************************************************************************
* Function Name  : UDISK_Up_CSW
* Description    : ˵˵2ϴCSW
* Input          : CBW_Tag_Save---ǩ
*				   CSW_Status---ǰִн״̬
* Output         : Bit_DISK_CSW---δϴCSW־
*				   Bit_DISK_Bluck_Up---ϴ־
*				   Bit_DISK_Bluck_Down---´־
* Return         : None
*******************************************************************************/
void UDISK_Up_CSW( void )
{
	Udisk_Transfer_Status = 0x00;		 										/* U̴״̬ */

	mBOC.mCSW.mCSW_Sig[ 0 ] = 'U';
	mBOC.mCSW.mCSW_Sig[ 1 ] = 'S';
	mBOC.mCSW.mCSW_Sig[ 2 ] = 'B';
	mBOC.mCSW.mCSW_Sig[ 3 ] = 'S';								 				/* ״̬CSWʶ־'USBS' */
	mBOC.mCSW.mCSW_Tag[ 0 ] = Udisk_CBW_Tag_Save[ 0 ];
	mBOC.mCSW.mCSW_Tag[ 1 ] = Udisk_CBW_Tag_Save[ 1 ];
	mBOC.mCSW.mCSW_Tag[ 2 ] = Udisk_CBW_Tag_Save[ 2 ];
	mBOC.mCSW.mCSW_Tag[ 3 ] = Udisk_CBW_Tag_Save[ 3 ];				 			/* ǩ,Ϊ֮ǰյCBWһ */
	mBOC.mCSW.mCSW_Residue[ 0 ] = 0x00;
	mBOC.mCSW.mCSW_Residue[ 1 ] = 0x00;
	mBOC.mCSW.mCSW_Residue[ 2 ] = 0x00;
	mBOC.mCSW.mCSW_Residue[ 3 ] = 0x00;
	mBOC.mCSW.mCSW_Status = Udisk_CSW_Status;							 		/* ǰִн״̬ */

	/* װؽϴ,ϴ */
	memcpy( &EP2_Tx_Databuf[ 0 ], (PUINT8)mBOC.buf, 0x0D );
    USBHSD->UEP2_TX_LEN  = 0x0D;
    USBHSD->UEP2_TX_CTRL &= ~USBHS_EP_T_RES_MASK;
    USBHSD->UEP2_TX_CTRL |= USBHS_EP_T_RES_ACK;
}

/*******************************************************************************
* Function Name  : UDISK_Up_OnePack
* Description    : USB洢豸ϴһ
*                  úU̶ʱʹ,ÿϴһݺ,Ҫж
*                  Ƿϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UDISK_Up_OnePack( void )
{	
	/* жǷҪ */
	if( UDISK_Sec_Pack_Count == 0x00 ) 	
	{
#if 0
	    /* add offset */
		FLASH_RD_Block_Start( UDISK_Cur_Sec_Lba * DEF_UDISK_SECTOR_SIZE + DEF_F_CDROM_DATA_ADDR );	   	/* FLASHݶȡʼ */
#else
		FLASH_RD_Block_Start( UDISK_Cur_Sec_Lba * DEF_UDISK_SECTOR_SIZE );      /* FLASHݶȡʼ */
#endif

	}

	/* ȡһݲϴ */
	FLASH_RD_Block( &EP2_Tx_Databuf[ 0 ], UDISK_Pack_Size );
    USBHSD->UEP2_TX_LEN  = UDISK_Pack_Size;
    USBHSD->UEP2_TX_CTRL &= ~USBHS_EP_T_RES_MASK;
    USBHSD->UEP2_TX_CTRL |= USBHS_EP_T_RES_ACK;

	/* жϵǰǷȡϴ */
	UDISK_Sec_Pack_Count++;
	UDISK_Transfer_DataLen -= UDISK_Pack_Size;
	if( UDISK_Sec_Pack_Count == ( DEF_UDISK_SECTOR_SIZE / UDISK_Pack_Size ) )
	{
		PIN_FLASH_CS_HIGH( );
		UDISK_Sec_Pack_Count = 0x00;
		UDISK_Cur_Sec_Lba++;
	}
	
	/* жǷȫϴ */	
 	if( UDISK_Transfer_DataLen == 0x00 )										/* ´,򷵻CSW */
	{	
		Udisk_Transfer_Status &= ~DEF_UDISK_BLUCK_UP_FLAG;						/* ϴ־ */																	 					
	}
}

/*******************************************************************************
* Function Name  : FLASH_Sector_Copy_From_Backup
* Description    : ݿָFLASH
*                                                ע: еС(512ֽ)д,Ҫ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void FLASH_Sector_Copy_From_Backup( UINT32 address )
{
    UINT8  i, count;
    UINT32 backup_address;
    UINT32 op_address;
    UINT8  offset;

    /* СFLASHС,ҪбݵȲ */
#if( DEF_CFG_DISK_SEC_SIZE == DEF_FLASH_SECTOR_SIZE )
    return;
#endif

    /* ָ */
    backup_address = (UINT32)Flash_Cur_Hold_SecNum * DEF_FLASH_SECTOR_SIZE;
    op_address = address;
    offset = 0x01;
    for( count = 0; count < DEF_FLASH_SECTOR_SIZE / DEF_UDISK_SECTOR_SIZE; count++ )
    {
        /* жϵǰСǷѴ */
        if( Flash_Used_Flag & offset )
        {
            /* ر */
            op_address += DEF_UDISK_SECTOR_SIZE;
            backup_address += DEF_UDISK_SECTOR_SIZE;
        }
        else
        {
            for( i = 0; i < ( DEF_UDISK_SECTOR_SIZE / DEF_FLASH_BUF_LEN ); i++ )
            {
                /* ȡݴ浽ʱ */
                FLASH_RD_Block_Start( backup_address );
                FLASH_RD_Block( Flash_BackUp_Buf, DEF_FLASH_BUF_LEN );
                PIN_FLASH_CS_HIGH( );

                /* ʱдĿ */
                FLASH_WR_Block( op_address, Flash_BackUp_Buf, DEF_FLASH_BUF_LEN );

                /* ر */
                op_address += DEF_FLASH_BUF_LEN;
                backup_address += DEF_FLASH_BUF_LEN;
            }
        }
        offset = offset << 1;
    }

    /* лݻַ */
    Flash_Cur_Hold_SecNum++;
    if( Flash_Cur_Hold_SecNum >= ( ( DEF_FLASH_COPY_SEC_NUM - 8 ) / 8 ) )
    {
        Flash_Cur_Hold_SecNum = 0x00;
    }
}

/*******************************************************************************
* Function Name  : FLASH_Sector_Copy_To_Backup
* Description    : ָFLASHݿ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void FLASH_Sector_Copy_To_Backup( UINT32 address )
{
    UINT8  i, count;
    UINT32 backup_address;
    UINT32 op_address;

    /* СFLASHС,ҪбݵȲ */
#if( DEF_CFG_DISK_SEC_SIZE == DEF_FLASH_SECTOR_SIZE )
    return;
#endif

    /* ָFLASH */
    backup_address = (UINT32)Flash_Cur_Hold_SecNum * DEF_FLASH_SECTOR_SIZE;
    FLASH_Erase_Sector( backup_address );                                       /* FLASH */

    /* ǰȫ */
    op_address = address;
    for( count = 0; count < DEF_FLASH_SECTOR_SIZE / DEF_UDISK_SECTOR_SIZE; count++ )
    {
        for( i = 0; i < ( DEF_UDISK_SECTOR_SIZE / DEF_FLASH_BUF_LEN ); i++ )
        {
            /* Դȡݴ浽ʱ */
            FLASH_RD_Block_Start( op_address );
            FLASH_RD_Block( Flash_BackUp_Buf, DEF_FLASH_BUF_LEN );
            PIN_FLASH_CS_HIGH( );

            /* ʱдĿ */
            FLASH_WR_Block( backup_address, Flash_BackUp_Buf, DEF_FLASH_BUF_LEN );

            /* ر */
            op_address += DEF_FLASH_BUF_LEN;
            backup_address += DEF_FLASH_BUF_LEN;
        }
    }
}

/*******************************************************************************
* Function Name  : UDISK_Down_OnePack
* Description    : USB洢豸һ´
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UDISK_Down_OnePack( UINT8 *pbuf, UINT16 packlen )
{
	UINT32 address;
	UINT32 sec_start_addr;
	UINT8  i;
	UINT32 count, offset;
		
	/* жǷҪ */
	if( UDISK_Sec_Pack_Count == 0x00 ) 	
	{
		/* 㵱ǰFLASHַʼַ */
		address = (UINT32)UDISK_Cur_Sec_Lba * DEF_UDISK_SECTOR_SIZE;
#if 0
		/* add offset */
		address += DEF_F_CDROM_DATA_ADDR;
#endif
		sec_start_addr = ( address / DEF_FLASH_SECTOR_SIZE ) * DEF_FLASH_SECTOR_SIZE;

		/* жǷв */
		if( Flash_Erase_Flag )
		{
			/* жϵǰַǷѲַ */
			if( sec_start_addr != Flash_Erase_Address )	
			{
				/* еݿԭ */
				FLASH_Sector_Copy_From_Backup( Flash_Erase_Address );
				Flash_Used_Flag = 0x00;
				Flash_Erase_Flag = 0x00;
			}
		}
							
		if( Flash_Erase_Flag == 0x00 )
		{		
			/* ǰFLASHݿ */
			FLASH_Sector_Copy_To_Backup( sec_start_addr );

			/* ǰFLASH */
			Flash_Erase_Address = sec_start_addr;
			FLASH_Erase_Sector( Flash_Erase_Address );							/* FLASH */
			Flash_Erase_Flag = 0x01;											/* FLASH־ */
			Flash_Used_Flag = 0x00;												/* FLASH־ */
		}
	}

	/* ´ֱдѲFLASH */
	address = (UINT32)UDISK_Cur_Sec_Lba * DEF_UDISK_SECTOR_SIZE;
	address += (UINT32)UDISK_Sec_Pack_Count * UDISK_Pack_Size;
#if 0
	/* add offset */
    address += DEF_F_CDROM_DATA_ADDR;
#endif
	FLASH_WR_Block( address, pbuf, packlen );									/* FLASHд */

	/* жϵǰСǷд */
	UDISK_Sec_Pack_Count++;
	UDISK_Transfer_DataLen -= UDISK_Pack_Size;
	if( UDISK_Sec_Pack_Count == ( DEF_UDISK_SECTOR_SIZE / UDISK_Pack_Size ) )
	{
		UDISK_Sec_Pack_Count = 0x00;
		UDISK_Cur_Sec_Lba++;

		address = (UINT32)UDISK_Cur_Sec_Lba * DEF_UDISK_SECTOR_SIZE;
#if 0
		/* add offset */
        address += DEF_F_CDROM_DATA_ADDR;
#endif
		sec_start_addr = ( ( address - 1 ) / DEF_FLASH_SECTOR_SIZE ) * DEF_FLASH_SECTOR_SIZE;
		count = ( address - sec_start_addr ) / DEF_UDISK_SECTOR_SIZE;
		count = count - 1;
		offset = 0x01;
		for( i = 0; i < count; i++ )
		{
			offset = offset << 1;	
		}
		Flash_Used_Flag |= offset;

		/* жǷȫ´ */
	 	if( UDISK_Transfer_DataLen == 0x00 )									/* ´,򷵻CSW */
		{	
			/* еݿԭ */
			FLASH_Sector_Copy_From_Backup( Flash_Erase_Address );
			Flash_Used_Flag = 0x00;
			Flash_Erase_Flag = 0x00;

			Udisk_Transfer_Status &= ~DEF_UDISK_BLUCK_DOWN_FLAG;				/* ´־ */																	 					
	
			/* ϴCSW */
			UDISK_Up_CSW( );	
		}
	}
}
