/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
  ģԶUSB豸Ụʹflash w25qxx Ϊ洢
  SPI flashʹSPI3IOϵ
  IO  -- func -- flash
  PB3 -- SCK  -- SCK
  PB4 -- MISO -- SDO
  PB5 -- MOSI -- SDI
  PE6  CS#  -- CS#
*/

#include "debug.h"
#include "ch32v30x_usbhs_device.h"
#include "SW_UDISK.H"
#include "SPI_FLASH.H"

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
	Delay_Init();
	USART_Printf_Init(115200);
	printf("SystemClk:%d\r\n",SystemCoreClock);

	/* SPI flash Init */
	FLASH_Port_Init( );

    /* FLASHоƬ */
    FLASH_IC_Check( );

    /* ʹU̹ */
    Udisk_Capability = Flash_Sector_Count;
    Udisk_Status |= DEF_UDISK_EN_FLAG;

    /* жǷʹUд */
#if( DEF_CFG_UDISK_WP_EN == 0x01 )
    Udisk_Status |= DEF_UDISK_WP_FLAG;
#endif

    /* жϵǰCDROMģʽUģʽ */
#if( DEF_CFG_CDROM_EN == 0x01 )
    Udisk_Status |= DEF_UDISK_CDROM_FLAG;
#endif

    /* USBHSʱӺ豸ʼ */
    USBHS_RCC_Init( );
    USBHS_Device_Init( ENABLE );
    NVIC_EnableIRQ( USBHS_IRQn );

	while(1)
	{ }
}
